/* Problem URL: https://codeforces.com/contest/2203/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

// constexpr int MAXN = 2e6 + 10;
// vi divs[MAXN];

void pre()
{
    // nrep(i, 1, MAXN) {
    //     for (int j = i; j < MAXN; j += i) {
    //         divs[j].push_back(i);
    //     }
    // }
}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;

    vi a(n);
    cin >> a;
    sortv(a);
    a.erase(unique(all(a)), a.end());

    vi c(n + m + 1);

    repv(i, a) {
        for (int j = i; j <= n + m; j += i) {
            c[j]++;
        }
    }


    int p[3] = {0, 0, 0};
    vi t(n + m + 1, -1);

    rep(i, m) {
        int now;
        cin >> now;
        if (t[now] != -1) {
            p[t[now]]++;
            continue;
        }

        int co = c[now];

        if (co > 0 && a.size() - co > 0) {
            p[2]++;
            t[now] = 2;
            continue;
        }

        if (co > 0) {
            p[0]++;
            t[now] = 0;
            continue;
        }

        p[1]++;
        t[now] = 1;
    }

    string win[] = {"Alice", "Bob"};

    int now = 0;
    while (true) {
        if (p[2]) {
            p[2]--;
            now ^= 1;
            continue;
        }

        if (p[now]) {
            p[now]--;
            now ^= 1;
            continue;
        }

        cout << win[now^1] << '\n';
        return;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
